local frame = CreateFrame("FRAME", "RecruitAFriendFrame");
local rafTarget = nil;
local rafLevelGranted = nil;

frame:RegisterEvent("PARTY_INVITE_REQUEST");
frame:RegisterEvent("CONFIRM_SUMMON");
frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("LFG_PROPOSAL_SHOW");
frame:RegisterEvent("LEVEL_GRANT_PROPOSED");
frame:RegisterEvent("AUTOEQUIP_BIND_CONFIRM");
frame:RegisterEvent("PLAYER_TARGET_CHANGED");
frame:RegisterEvent("PLAYER_LEVEL_UP");

frame:RegisterEvent("PLAYER_DEAD");


SLASH_RECRUITAFRIEND1, SLASH_RECRUITAFRIEND2 = '/raf', '/recruitafriend';
local function RecruitAFriendCommands(command, msg, arg1, arg2)
    var = { strsplit(" ", command) }
    if var[1]=="summon" then
      start, duration = GetSummonFriendCooldown();
      name, realm = UnitName("target");

      if duration==0 then
        if name==nil then
          if var[2]==nil then

          else
            SummonFriend(var[2])
          end
        else
           SummonFriend(name)
        end
      else
        print("Your last summon was at "..SecondsToTime(start).." which is "..SecondsToTime(duration).." ago")
      end
    elseif var[1]=="invite" then
      name, realm = UnitName("target");
        if name==nil then
          if var[2]==nil then

          else
             InviteUnit(var[2])
          end
        else
          InviteUnit(name)
        end
    elseif var[1]=="grant" then
      name, realm = UnitName("target");
        if name==nil then
          if var[2]==nil then

          else
             GrantLevel(var[2],1)
          end
        else
           GrantLevel(name,1)
        end
    elseif var[1]=="acceptlevels" then
       if var[2]=="1" then
          var[2]="Allow";
          raAcceptLevels = 1;
       elseif var[2]=="on" then
          var[2]="Allow";
          raAcceptLevels = 1;
       elseif var[2]=="enabled" then
          var[2]="Allow";
          raAcceptLevels = 1;
       elseif var[2]=="yes" then
          var[2]="Allow";
          raAcceptLevels = 1;
       elseif var[2]=="allow" then
          var[2]="Allow";
          raAcceptLevels = 1;
       else
          var[2]="Do Not Allow";
          raAcceptLevels = 0;
       end
       print(var[2].." automatic levels to be granted to this character")
    elseif var[1]=="acceptsummons" then
       if var[2]=="1" then
          var[2]="Allow";
          raAcceptSummons = 1;
       elseif var[2]=="on" then
          var[2]="Allow";
          raAcceptSummons = 1;
       elseif var[2]=="enabled" then
          var[2]="Allow";
          raAcceptSummons = 1;
       elseif var[2]=="yes" then
          var[2]="Allow";
          raAcceptSummons = 1;
       elseif var[2]=="allow" then
          var[2]="Allow";
          raAcceptSummons = 1;
       else
          var[2]="Do Not Allow";
          raAcceptSummons = 0;
       end
       print(var[2].." automatic summons to be sent to this character")
    elseif var[1]=="acceptinvites" then
       if var[2]=="1" then
          var[2]="Allow";
          raAcceptInvites = 1;
       elseif var[2]=="on" then
          var[2]="Allow";
          raAcceptInvites = 1;
       elseif var[2]=="enabled" then
          var[2]="Allow";
          raAcceptInvites = 1;
       elseif var[2]=="yes" then
          var[2]="Allow";
          raAcceptInvites = 1;
       elseif var[2]=="allow" then
          var[2]="Allow";
          raAcceptInvites = 1;
       else
          var[2]="Do Not Allow";
          raAcceptInvites = 0;
       end
       print(var[2].." automatic group invitations to be sent to this character")
    elseif var[1]=="add" then
       RAFriendAdd(var[2])
    elseif var[1]=="friends" then
      for k,v in pairs(raFriends) do
         print("RAF Buddy: "..v)
      end
    else
       print("Recruit-A-Friend Command List")
       print("/raf summon friend")
       print("/raf invite friend")
       print("/raf grant friend")
       print("/raf acceptlevels on/off")
       print("/raf acceptsummons on/off")
       print("/raf acceptinvites on/off")
       print("/raf add friend")
       print("/raf friends")
    end
end

local function eventHandler(info, event, sender, name)
   if event=="PARTY_INVITE_REQUEST" then
     if sender==nil then
       isLinked=nil
     else
       isLinked = IsReferAFriendLinked(sender);
     end
     if isLinked==nil then
        isLinked=RAFriendExists(sender);
     end
     if isLinked==1 then
        if raAcceptInvites==1 then
          AcceptGroup();
          frame:RegisterEvent("PARTY_MEMBERS_CHANGED");
        end
     end
   elseif event=="CONFIRM_SUMMON" then
--      GetSummonConfirmSummoner()
--     isLinked = IsReferAFriendLinked(sender);
--     isLinked=nil;
--     print("you are being summoned by "..name);
--     if isLinked==nil then
--        isLinked=RAFriendExists(sender);
--     end
     isLinked=1;
     if isLinked==1 then
       if raAcceptSummons==1 then
          ConfirmSummon();
       else
--        print(sender);
          CancelSummon();
       end
     else
       CancelSummon();
     end
   elseif event=="LEVEL_GRANT_PROPOSED" then
     isLinked = IsReferAFriendLinked(sender);
     if isLinked==nil then
        isLinked=RAFriendExists(sender);
     end
     if isLinked==1 then
        if raAcceptLevels==1 then
          rafLevelGranted=sender;
          AcceptLevelGrant()
          print(sender);
        else
          DeclineLevelGrant();
        end
     else
       DeclineLevelGrant();
     end
   elseif event=="ADDON_LOADED" then
     if sender=="Recruit-A-Friend" then
	   if not ( raFriends ) then
          raFriends = { }
       end
	   if not ( raAcceptLevels ) then
          raAcceptLevels = 0
       end
	   if not ( raAcceptSummons ) then
          raAcceptSummons = 1
       end
	   if not ( raAcceptInvites ) then
          raAcceptInvites = 1
       end
       print("Recruit-A-Friend Addon Loaded")
       print("You have "..#raFriends.." friend(s) on your Recruit-A-Friend buddy list")
       if raAcceptLevels==1 then
         print("Accepting granted levels")
       end
       if raAcceptSummons==1 then
         print("Accepting summons")
       end
       if raAcceptInvites==1 then
         print("Accepting party invitations")
       end
     end
   elseif event=="LFG_PROPOSAL_SHOW" then
     AcceptProposal();
   elseif event=="PLAYER_DEAD" then
     frame:RegisterEvent("RESURRECT_REQUEST","acceptResurrection");
     frame:RegisterEvent("PLAYER_UNGHOST","acceptResurrection");
   elseif event=="AUTOEQUIP_BIND_CONFIRM" then
     ConfirmBindOnUse();
   elseif event=="PLAYER_TARGET_CHANGED" then
      rafTarget = name
   elseif event=="PLAYER_LEVEL_UP" then
       local newlevel = sender
       local togo = MAX_PLAYER_LEVEL - newlevel
       rafLevelGranted = nil
   elseif event=="PARTY_MEMBERS_CHANGED" then
       StaticPopup_Hide("PARTY_INVITE");
       frame:UnregisterEvent("PARTY_MEMBERS_CHANGED");
   end
end

function rafClosePartyPopup()
    StaticPopup_Hide("PARTY_INVITE");
    print("window should be closed event");
    frame:UnregisterEvent("PARTY_MEMBERS_CHANGED");
end

function acceptResurrection(info, event, sender)
   AcceptResurrect();
   frame:UnregisterEvent("RESURRECT_REQUEST");
   frame:UnregisterEvent("PLAYER_UNGHOST");
end

function RAFriendAdd(friend)
  if RAFriendExists(friend)==0 then
    table.insert(raFriends,friend)
    print(friend.." was added to your Recruit-A-Friend buddy list")
  else
    print(friend.." already exists on your Recruit-A-Friend buddy list")
  end
end

function RAFriendExists(friend)
  myreturn=0;
  if (#raFriends==0) then
    myreturn=0;
  else
    for k,v in pairs(raFriends) do
        if strlower(v)==strlower(friend) then
           myreturn=1;
        end
    end
  end
  return myreturn;
end

frame:SetScript("OnEvent", eventHandler);
SlashCmdList["RECRUITAFRIEND"] = RecruitAFriendCommands;
